#Credits: Based on "Toggle_units Inch to mm" by 3DMON which was based on "toggle_units_5icons" by Matt666.
#This version by kyyu, March 2011.  3DMON's version compacted the orginal to just 2 options (inch/mm). 
#I added a 3rd option: fractional.  This version works with SU8.
# - update misc stuff for upload to skechucation - July 6, 2011 - changed name to "toggle_units_3icons"

#Description:  There are 3 choices:
#1)  Fractional - percision 1/64"
#2)  decimal Inch - percision 0.0001
#3)  decimal mm - percision 0.001

module KY_toggle_units
	module_function

	def toggle_units(int)
		model = Sketchup.active_model		
		case int
			when 8	# fractional
				model.options['UnitsOptions']['LengthFormat'] = 3			# fractional
				model.options['UnitsOptions']['LengthPrecision'] = 6	# 1/64"
			when 0	# decimal inch
				model.options['UnitsOptions']['LengthFormat'] = 0			# decimal
				model.options['UnitsOptions'][2] = int
				model.options['UnitsOptions']['LengthPrecision'] = 4	# 0.0001
			when 2	# decimal mm 
				model.options['UnitsOptions']['LengthFormat'] = 0			# decimal
				model.options['UnitsOptions'][2] = int
				model.options['UnitsOptions']['LengthPrecision'] = 3	# 0.001			
		end
		model.active_view.invalidate
		return nil
	end

	def toggle_units_validation_proc(int)
		model = Sketchup.active_model
		case int
			when 0,2
				if (model.options['UnitsOptions'][2] == int) and (model.options['UnitsOptions']['LengthFormat'] == 0)
					return MF_CHECKED
				else
					return MF_UNCHECKED
				end
			when 8
				if model.options['UnitsOptions']['LengthFormat'] == 3
					return MF_CHECKED
				else
					return MF_UNCHECKED
				end
		end		
	end
	


	if not file_loaded?('toggle_units_3icons')
		tb = UI::Toolbar.new('Units')
	#########	
		cmd = UI::Command.new('Fractional') { toggle_units(8) }
		cmd.small_icon = cmd.large_icon = File.join(File.dirname(__FILE__),'toggle_units_3icons/tuf.gif')
		cmd.tooltip = cmd.status_bar_text = 'Drawing unit -> Fractional'
		cmd.set_validation_proc { toggle_units_validation_proc(8) }
		tb.add_item(cmd)
	##########	
		cmd = UI::Command.new('Inch') { toggle_units(0) }
		cmd.small_icon = cmd.large_icon = File.join(File.dirname(__FILE__),'toggle_units_3icons/tuin.gif')
		cmd.tooltip = cmd.status_bar_text = 'Drawing unit -> Inch'
		cmd.set_validation_proc { toggle_units_validation_proc(0) }
		tb.add_item(cmd)
	#	tb.add_separator
		cmd = UI::Command.new('Millimeter') { toggle_units(2) }
		cmd.small_icon = cmd.large_icon = File.join(File.dirname(__FILE__),'toggle_units_3icons/tumm.gif')
		cmd.tooltip = cmd.status_bar_text = 'Drawing unit -> Millimeter'
		cmd.set_validation_proc { toggle_units_validation_proc(2) }
		tb.add_item(cmd)
		
		
		state = tb.get_last_state 
		if(state == TB_NEVER_SHOWN)
			tb.show 
		elsif (state == TB_VISIBLE)
			tb.restore
		end
	end
	file_loaded('toggle_units_3icons')

end




